/*
 * MINUM.H -- LIBMI numeric datatypes
 *
 *      Copyright 1995 Illustra Systems, Inc.
 *      All rights reserved.      See files/copyright.
 */

#ifndef	_MINUM_H_
#define	_MINUM_H_

#ifndef	_MITYPES_H_
#include "mitypes.h"
#endif /* _MITYPES_H_ */


/*
**	The exact numeric data type is stored as a varlena of two byte ints.
** The number of int16s in the array is just enough to satisfy the precision
** requirements of the number.  The first int16 is treated as signed, the
** remainder are unsigned.
**
** The typedef is really just the first 64 bits of the number,
** preceded by the ever-popular varlena length.
*/

typedef mi_unsigned_smallint mi_numradix;

#define MI_NUMRADIXBITS	16
#define MI_NUMRADIX	(1L << MI_NUMRADIXBITS)


typedef struct mi_numeric
{
	MI_VLLEN	vl_len;		/* the length of a mi_varlena */
	mi_numradix	num_words[4];	/* for the fips127 precision of 15  */
					/* the actual size usually is different */
} mi_numeric;

/*
** Numeric and Decimal have the same representation.
** Currently they behave identically as well.
*/
typedef mi_numeric mi_decimal;

#define	MI_FP_ARGTYPEPREC(fp, nth)		MI_FP_ARGTYPEBOUND((fp), (nth))
#define	MI_FP_SETARGTYPEPREC(fp, nth, prec)	MI_FP_SETARGTYPEBOUND((fp), (nth), (prec))

#define	MI_FP_ARGTYPESCALE(fp, nth)		(int) MI_FP_ARGTYPEPARAM((fp), (nth))
#define	MI_FP_SETARGTYPESCALE(fp, nth, scale)	MI_FP_SETARGTYPEPARAM((fp), (nth), (void *) (scale))

#define	MI_FP_RETTYPEPREC(fp)			MI_FP_RETTYPEBOUND(fp)
#define	MI_FP_SETRETTYPEPREC(fp, prec)		MI_FP_SETRETTYPEBOUND((fp), (prec))

#define	MI_FP_RETTYPESCALE(fp)			(int) MI_FP_RETTYPEPARAM(fp)
#define	MI_FP_SETRETTYPESCALE(fp, scale)	MI_FP_SETRETTYPEPARAM((fp), (void *) (scale))

#endif /* _MINUM_H_ */
